package traffic.light;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;

import javax.swing.JPanel;

import traffic.light.TrafficLight.Alignment;

public class CrossWalkPanel extends JPanel {

	private static final long serialVersionUID = -7137708533029709629L;
	protected TrafficLight trafficLight;

	
	public CrossWalkPanel() {
		super();
		trafficLight = new TrafficLight(Alignment.VERTICAL);
	}
	
	public TrafficLight getTrafficLight() {
		return trafficLight;
	}

	public void paint(Graphics g) {
		paintTrafficLights(g);
		g.dispose();
	}

	protected void paintTrafficLights(Graphics g) {
		trafficLight.updatePosition(new Point(170, 50));
		trafficLight.paint(g);
	}
	
	protected void paint(Dimension area, int x, int y, boolean horizontally, Graphics g) {
		g.fillRect(x, y, 
				horizontally ? area.width : area.height, 
				horizontally ? area.height : area.width);
	}
}
