/**
 * Copyright (c) 2016 committers of YAKINDU and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:
 * 	committers of YAKINDU - initial API and implementation
 * 
 */
package traffic.light;

import java.awt.BorderLayout;
import java.awt.Graphics;

import javax.swing.JFrame;

import traffic.light.trafficlightctrl_generatoracceptor.ITrafficLightCtrl_GeneratorAcceptorStatemachine;
import traffic.light.trafficlightctrl_generatoracceptor.SynchronizedTrafficLightCtrl_GeneratorAcceptorStatemachine;

/**
 * 
 * @author Tesch
 *
 */

public class TrafficlightDemo extends JFrame {

	private static final long serialVersionUID = -8909693541678814631L;

	protected SynchronizedTrafficLightCtrl_GeneratorAcceptorStatemachine statemachine;

	protected TimerService timer;

	private CrossWalkPanel crossing;

	private ButtonPanel buttonPanel;

	public static void main(String[] args) {
		TrafficlightDemo application = new TrafficlightDemo();
		application.createContents();
		application.setupStatemachine();
		application.run();
	}

	protected void run() {
		statemachine.enter();
		RuntimeService.getInstance().registerStatemachine(statemachine, 100);
	}

	protected void createContents() {
		setLayout(new BorderLayout());
		setTitle("Crosswalk traffic light");
		crossing = new CrossWalkPanel();
		add(BorderLayout.CENTER, crossing);
		buttonPanel = new ButtonPanel();
		add(BorderLayout.SOUTH, buttonPanel);
		setSize(440, 250);
		setVisible(true);
	}

	@Override
	public void paint(Graphics g) {
		super.paint(g);
	}

	protected void setupStatemachine() {
		statemachine = new SynchronizedTrafficLightCtrl_GeneratorAcceptorStatemachine();
		timer = new TimerService();
		statemachine.setTimer(timer);
		statemachine.getSCInterface().setSCInterfaceOperationCallback(new ITrafficLightCtrl_GeneratorAcceptorStatemachine.SCInterfaceOperationCallback() {
			@Override
			public void synchronize() {
				checkTrafficLightStates();
				repaint();
			}
			@Override
			public void onFinished() {
				System.out.println("test passed!");
				System.exit(0);
			}
		});

		// buttonPanel.getPoliceInterrupt()
		//		.addActionListener(e -> statemachine.getSCInterface().raisePolice());
		
		statemachine.init();
	}

	
	protected void checkTrafficLightStates() {
		crossing.getTrafficLight().setRed(statemachine.getSCITrafficLight().getRed());
		crossing.getTrafficLight().setYellow(statemachine.getSCITrafficLight().getYellow());
		crossing.getTrafficLight().setGreen(statemachine.getSCITrafficLight().getGreen());
	}
}
