package traffic.light;

import traffic.light.trafficlightctrl.ITrafficLightCtrlStatemachine;
import traffic.light.trafficlightctrl.RunnableTrafficLightCtrlStatemachineWrapper;

public class TrafficlightDemo {
	
	protected RunnableTrafficLightCtrlStatemachineWrapper statemachine;

	protected TimerService timer;

	public static void main(String[] args) {
		TrafficlightDemo application = new TrafficlightDemo();
		application.setupStatemachine();
		application.run();
	}

	protected void run() {
		statemachine.enter();
		statemachine.run();
	}

	protected void setupStatemachine() {
		statemachine = new RunnableTrafficLightCtrlStatemachineWrapper();
		timer = new TimerService();
		statemachine.setTimer(timer);
		
		statemachine.getSCInterface().getListeners().add(new ITrafficLightCtrlStatemachine.SCInterfaceListener() {
			
			@Override
			public void onColorRaised(String value) {
				System.out.println("Color: " + value);
			}
		});
		
		statemachine.init();
	}
}
