package traffic.light.trafficlightctrl;

import java.util.List;
import traffic.light.IStatemachine;
import traffic.light.ITimerCallback;

public interface ITrafficLightCtrlStatemachine extends ITimerCallback,IStatemachine {

	public interface SCInterface {
	
		public void raisePolice_interrupt();
		
		public void raisePedestrian_request();
		
	}
	
	public SCInterface getSCInterface();
	
	public interface SCICars {
	
		public boolean isRaisedDisplayRed();
		
		public boolean isRaisedDisplayGreen();
		
		public boolean isRaisedDisplayYellow();
		
		public boolean isRaisedDisplayNone();
		
	public List<SCICarsListener> getListeners();
	}
	
	public interface SCICarsListener {
	
		public void onDisplayRedRaised();
		public void onDisplayGreenRaised();
		public void onDisplayYellowRaised();
		public void onDisplayNoneRaised();
		}
	
	public SCICars getSCICars();
	
	public interface SCIPedestrians {
	
		public boolean isRaisedDisplayRed();
		
		public boolean isRaisedDisplayGreen();
		
		public boolean isRaisedDisplayNone();
		
	public List<SCIPedestriansListener> getListeners();
	}
	
	public interface SCIPedestriansListener {
	
		public void onDisplayRedRaised();
		public void onDisplayGreenRaised();
		public void onDisplayNoneRaised();
		}
	
	public SCIPedestrians getSCIPedestrians();
	
}
