package traffic.light;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;

import javax.swing.JPanel;

public class CrossWalkPanel extends JPanel {

	private static final long serialVersionUID = -7137708533029709629L;
	protected TrafficLight trafficLight;
	protected PedestrianLight pedLight;

	
	public CrossWalkPanel() {
		super();
		trafficLight = new TrafficLight(TrafficLight.Alignment.VERTICAL);
		pedLight = new PedestrianLight(PedestrianLight.Alignment.HORIZONTAL);
	}
	
	public TrafficLight getTrafficLight() {
		return trafficLight;
	}

	public PedestrianLight getPedLight() {
		return pedLight;
	}

	public void paint(Graphics g) {
		paintTrafficLights(g);
		paintPedestrainLights(g);
		g.dispose();
	}

	protected void paintPedestrainLights(Graphics g) {
		pedLight.updatePosition(new Point(260, 90));
		pedLight.paint(g);
	}

	protected void paintTrafficLights(Graphics g) {
		trafficLight.updatePosition(new Point(170, 50));
		trafficLight.paint(g);
	}
	
	protected void paint(Dimension area, int x, int y, boolean horizontally, Graphics g) {
		g.fillRect(x, y, 
				horizontally ? area.width : area.height, 
				horizontally ? area.height : area.width);
	}
}
