package traffic.light.trafficlightctrltest;
import traffic.light.ITimer;

public class TrafficLightCtrlTestStatemachine implements ITrafficLightCtrlTestStatemachine {

	protected class SCInterfaceImpl implements SCInterface {
	
		private SCInterfaceOperationCallback operationCallback;
		
		public void setSCInterfaceOperationCallback(
				SCInterfaceOperationCallback operationCallback) {
			this.operationCallback = operationCallback;
		}
		private boolean displayRed;
		
		public boolean isRaisedDisplayRed() {
			return displayRed;
		}
		
		protected void raiseDisplayRed() {
			displayRed = true;
		}
		
		private boolean displayGreen;
		
		public boolean isRaisedDisplayGreen() {
			return displayGreen;
		}
		
		protected void raiseDisplayGreen() {
			displayGreen = true;
		}
		
		private boolean displayYellow;
		
		public boolean isRaisedDisplayYellow() {
			return displayYellow;
		}
		
		protected void raiseDisplayYellow() {
			displayYellow = true;
		}
		
		private boolean displayNone;
		
		public boolean isRaisedDisplayNone() {
			return displayNone;
		}
		
		protected void raiseDisplayNone() {
			displayNone = true;
		}
		
		protected void clearEvents() {
		}
		protected void clearOutEvents() {
		
		displayRed = false;
		displayGreen = false;
		displayYellow = false;
		displayNone = false;
		}
		
	}
	
	protected SCInterfaceImpl sCInterface;
	
	private boolean initialized = false;
	
	public enum State {
		main_trafficsystem,
		main_trafficsystem_generator_running,
		main_trafficsystem_generator_running_r1_Waiting,
		main_trafficsystem_generator_running_r1_GeneratingPolice,
		main_trafficsystem_generator_running_r1_GeneratingPolice2,
		main_trafficsystem_trafficlight_trafficlight,
		main_trafficsystem_trafficlight_trafficlight_trafficlight_normal,
		main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow,
		main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green,
		main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red,
		main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted,
		main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black,
		main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow,
		main_trafficsystem_acceptor_InPolice,
		main_trafficsystem_acceptor_InNormal,
		main_trafficsystem_acceptor_Waiting,
		main_trafficsystem_acceptor_InNormal_2,
		main_trafficsystem_acceptor_Timeout,
		main__final_,
		$NullState$
	};
	
	private State[] historyVector = new State[1];
	private final State[] stateVector = new State[3];
	
	private int nextStateIndex;
	
	private ITimer timer;
	
	private final boolean[] timeEvents = new boolean[10];
	
	private boolean police;
	public TrafficLightCtrlTestStatemachine() {
		sCInterface = new SCInterfaceImpl();
	}
	
	public void init() {
		this.initialized = true;
		if (timer == null) {
			throw new IllegalStateException("timer not set.");
		}
		if (this.sCInterface.operationCallback == null) {
			throw new IllegalStateException("Operation callback for interface sCInterface must be set.");
		}
		
		for (int i = 0; i < 3; i++) {
			stateVector[i] = State.$NullState$;
		}
		for (int i = 0; i < 1; i++) {
			historyVector[i] = State.$NullState$;
		}
		clearEvents();
		clearOutEvents();
	}
	
	public void enter() {
		if (!initialized) {
			throw new IllegalStateException(
					"The state machine needs to be initialized first by calling the init() function.");
		}
		if (timer == null) {
			throw new IllegalStateException("timer not set.");
		}
		enterSequence_main_default();
	}
	
	public void exit() {
		exitSequence_main();
	}
	
	/**
	 * @see IStatemachine#isActive()
	 */
	public boolean isActive() {
		return stateVector[0] != State.$NullState$||stateVector[1] != State.$NullState$||stateVector[2] != State.$NullState$;
	}
	
	/** 
	* @see IStatemachine#isFinal()
	*/
	public boolean isFinal() {
		return (stateVector[0] == State.main__final_) && (stateVector[1] == State.$NullState$) && (stateVector[2] == State.$NullState$);
	}
	/**
	* This method resets the incoming events (time events included).
	*/
	protected void clearEvents() {
		sCInterface.clearEvents();
		police = false;
		for (int i=0; i<timeEvents.length; i++) {
			timeEvents[i] = false;
		}
	}
	
	/**
	* This method resets the outgoing events.
	*/
	protected void clearOutEvents() {
		sCInterface.clearOutEvents();
	}
	
	/**
	* Returns true if the given state is currently active otherwise false.
	*/
	public boolean isStateActive(State state) {
	
		switch (state) {
		case main_trafficsystem:
			return stateVector[0].ordinal() >= State.
					main_trafficsystem.ordinal()&& stateVector[0].ordinal() <= State.main_trafficsystem_acceptor_Timeout.ordinal();
		case main_trafficsystem_generator_running:
			return stateVector[0].ordinal() >= State.
					main_trafficsystem_generator_running.ordinal()&& stateVector[0].ordinal() <= State.main_trafficsystem_generator_running_r1_GeneratingPolice2.ordinal();
		case main_trafficsystem_generator_running_r1_Waiting:
			return stateVector[0] == State.main_trafficsystem_generator_running_r1_Waiting;
		case main_trafficsystem_generator_running_r1_GeneratingPolice:
			return stateVector[0] == State.main_trafficsystem_generator_running_r1_GeneratingPolice;
		case main_trafficsystem_generator_running_r1_GeneratingPolice2:
			return stateVector[0] == State.main_trafficsystem_generator_running_r1_GeneratingPolice2;
		case main_trafficsystem_trafficlight_trafficlight:
			return stateVector[1].ordinal() >= State.
					main_trafficsystem_trafficlight_trafficlight.ordinal()&& stateVector[1].ordinal() <= State.main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow.ordinal();
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal:
			return stateVector[1].ordinal() >= State.
					main_trafficsystem_trafficlight_trafficlight_trafficlight_normal.ordinal()&& stateVector[1].ordinal() <= State.main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red.ordinal();
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow:
			return stateVector[1] == State.main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green:
			return stateVector[1] == State.main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red:
			return stateVector[1] == State.main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted:
			return stateVector[1].ordinal() >= State.
					main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted.ordinal()&& stateVector[1].ordinal() <= State.main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow.ordinal();
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black:
			return stateVector[1] == State.main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow:
			return stateVector[1] == State.main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow;
		case main_trafficsystem_acceptor_InPolice:
			return stateVector[2] == State.main_trafficsystem_acceptor_InPolice;
		case main_trafficsystem_acceptor_InNormal:
			return stateVector[2] == State.main_trafficsystem_acceptor_InNormal;
		case main_trafficsystem_acceptor_Waiting:
			return stateVector[2] == State.main_trafficsystem_acceptor_Waiting;
		case main_trafficsystem_acceptor_InNormal_2:
			return stateVector[2] == State.main_trafficsystem_acceptor_InNormal_2;
		case main_trafficsystem_acceptor_Timeout:
			return stateVector[2] == State.main_trafficsystem_acceptor_Timeout;
		case main__final_:
			return stateVector[0] == State.main__final_;
		default:
			return false;
		}
	}
	
	/**
	* Set the {@link ITimer} for the state machine. It must be set
	* externally on a timed state machine before a run cycle can be correct
	* executed.
	* 
	* @param timer
	*/
	public void setTimer(ITimer timer) {
		this.timer = timer;
	}
	
	/**
	* Returns the currently used timer.
	* 
	* @return {@link ITimer}
	*/
	public ITimer getTimer() {
		return timer;
	}
	
	public void timeElapsed(int eventID) {
		timeEvents[eventID] = true;
	}
	
	public SCInterface getSCInterface() {
		return sCInterface;
	}
	
	private void raisePolice() {
		police = true;
	}
	
	
	public boolean isRaisedDisplayRed() {
		return sCInterface.isRaisedDisplayRed();
	}
	
	public boolean isRaisedDisplayGreen() {
		return sCInterface.isRaisedDisplayGreen();
	}
	
	public boolean isRaisedDisplayYellow() {
		return sCInterface.isRaisedDisplayYellow();
	}
	
	public boolean isRaisedDisplayNone() {
		return sCInterface.isRaisedDisplayNone();
	}
	
	private boolean check_main_trafficsystem_generator_running_tr0_tr0() {
		return true && isStateActive(State.main_trafficsystem_trafficlight_trafficlight) && true && isStateActive(State.main_trafficsystem_acceptor_Timeout) && true;
	}
	
	private boolean check_main_trafficsystem_generator_running_r1_Waiting_tr0_tr0() {
		return timeEvents[0];
	}
	
	private boolean check_main_trafficsystem_generator_running_r1_GeneratingPolice_tr0_tr0() {
		return timeEvents[1];
	}
	
	private boolean check_main_trafficsystem_generator_running_r1_GeneratingPolice2_tr0_tr0() {
		return true && isStateActive(State.main_trafficsystem_trafficlight_trafficlight) && true && isStateActive(State.main_trafficsystem_acceptor_InNormal_2) && true;
	}
	
	private boolean check_main_trafficsystem_trafficlight_trafficlight_tr0_tr0() {
		return true && isStateActive(State.main_trafficsystem_generator_running_r1_GeneratingPolice2) && true && isStateActive(State.main_trafficsystem_acceptor_InNormal_2) && true;
	}
	
	private boolean check_main_trafficsystem_trafficlight_trafficlight_tr1_tr1() {
		return true && isStateActive(State.main_trafficsystem_generator_running) && true && isStateActive(State.main_trafficsystem_acceptor_Timeout) && true;
	}
	
	private boolean check_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_tr0_tr0() {
		return police;
	}
	
	private boolean check_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow_tr0_tr0() {
		return timeEvents[2];
	}
	
	private boolean check_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green_tr0_tr0() {
		return timeEvents[3];
	}
	
	private boolean check_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red_tr0_tr0() {
		return timeEvents[4];
	}
	
	private boolean check_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_tr0_tr0() {
		return police;
	}
	
	private boolean check_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black_tr0_tr0() {
		return timeEvents[5];
	}
	
	private boolean check_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow_tr0_tr0() {
		return timeEvents[6];
	}
	
	private boolean check_main_trafficsystem_acceptor_InPolice_tr0_tr0() {
		return isStateActive(State.main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green);
	}
	
	private boolean check_main_trafficsystem_acceptor_InPolice_tr1_tr1() {
		return timeEvents[7];
	}
	
	private boolean check_main_trafficsystem_acceptor_InNormal_tr0_tr0() {
		return isStateActive(State.main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted);
	}
	
	private boolean check_main_trafficsystem_acceptor_InNormal_tr1_tr1() {
		return timeEvents[8];
	}
	
	private boolean check_main_trafficsystem_acceptor_Waiting_tr0_tr0() {
		return isStateActive(State.main_trafficsystem_trafficlight_trafficlight_trafficlight_normal);
	}
	
	private boolean check_main_trafficsystem_acceptor_Waiting_tr1_tr1() {
		return timeEvents[9];
	}
	
	private boolean check_main_trafficsystem_acceptor_InNormal_2_tr0_tr0() {
		return true && isStateActive(State.main_trafficsystem_generator_running_r1_GeneratingPolice2) && true && isStateActive(State.main_trafficsystem_trafficlight_trafficlight) && true;
	}
	
	private boolean check_main_trafficsystem_acceptor_Timeout_tr0_tr0() {
		return true && isStateActive(State.main_trafficsystem_generator_running) && true && isStateActive(State.main_trafficsystem_trafficlight_trafficlight) && true;
	}
	
	private void effect_main_trafficsystem_generator_running_tr0() {
		exitSequence_main_trafficsystem();
		react_main__sync1();
	}
	
	private void effect_main_trafficsystem_generator_running_r1_Waiting_tr0() {
		exitSequence_main_trafficsystem_generator_running_r1_Waiting();
		enterSequence_main_trafficsystem_generator_running_r1_GeneratingPolice_default();
	}
	
	private void effect_main_trafficsystem_generator_running_r1_GeneratingPolice_tr0() {
		exitSequence_main_trafficsystem_generator_running_r1_GeneratingPolice();
		enterSequence_main_trafficsystem_generator_running_r1_GeneratingPolice2_default();
	}
	
	private void effect_main_trafficsystem_generator_running_r1_GeneratingPolice2_tr0() {
		exitSequence_main_trafficsystem();
		react_main__sync0();
	}
	
	private void effect_main_trafficsystem_trafficlight_trafficlight_tr0() {
		exitSequence_main_trafficsystem();
		react_main__sync0();
	}
	
	private void effect_main_trafficsystem_trafficlight_trafficlight_tr1() {
		exitSequence_main_trafficsystem();
		react_main__sync1();
	}
	
	private void effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_tr0() {
		exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal();
		enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_default();
	}
	
	private void effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow_tr0() {
		exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow();
		enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red_default();
	}
	
	private void effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green_tr0() {
		exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green();
		enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow_default();
	}
	
	private void effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red_tr0() {
		exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red();
		enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green_default();
	}
	
	private void effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_tr0() {
		exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted();
		react_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_history();
	}
	
	private void effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black_tr0() {
		exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black();
		enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow_default();
	}
	
	private void effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow_tr0() {
		exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow();
		enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black_default();
	}
	
	private void effect_main_trafficsystem_acceptor_InPolice_tr0() {
		exitSequence_main_trafficsystem_acceptor_InPolice();
		enterSequence_main_trafficsystem_acceptor_InNormal_2_default();
	}
	
	private void effect_main_trafficsystem_acceptor_InPolice_tr1() {
		exitSequence_main_trafficsystem_acceptor_InPolice();
		enterSequence_main_trafficsystem_acceptor_Timeout_default();
	}
	
	private void effect_main_trafficsystem_acceptor_InNormal_tr0() {
		exitSequence_main_trafficsystem_acceptor_InNormal();
		enterSequence_main_trafficsystem_acceptor_InPolice_default();
	}
	
	private void effect_main_trafficsystem_acceptor_InNormal_tr1() {
		exitSequence_main_trafficsystem_acceptor_InNormal();
		enterSequence_main_trafficsystem_acceptor_Timeout_default();
	}
	
	private void effect_main_trafficsystem_acceptor_Waiting_tr0() {
		exitSequence_main_trafficsystem_acceptor_Waiting();
		enterSequence_main_trafficsystem_acceptor_InNormal_default();
	}
	
	private void effect_main_trafficsystem_acceptor_Waiting_tr1() {
		exitSequence_main_trafficsystem_acceptor_Waiting();
		enterSequence_main_trafficsystem_acceptor_Timeout_default();
	}
	
	private void effect_main_trafficsystem_acceptor_InNormal_2_tr0() {
		exitSequence_main_trafficsystem();
		react_main__sync0();
	}
	
	private void effect_main_trafficsystem_acceptor_Timeout_tr0() {
		exitSequence_main_trafficsystem();
		react_main__sync1();
	}
	
	/* Entry action for state 'Waiting'. */
	private void entryAction_main_trafficsystem_generator_running_r1_Waiting() {
		timer.setTimer(this, 0, 6 * 1000, false);
	}
	
	/* Entry action for state 'GeneratingPolice'. */
	private void entryAction_main_trafficsystem_generator_running_r1_GeneratingPolice() {
		timer.setTimer(this, 1, 3 * 1000, false);
		
		raisePolice();
	}
	
	/* Entry action for state 'GeneratingPolice2'. */
	private void entryAction_main_trafficsystem_generator_running_r1_GeneratingPolice2() {
		raisePolice();
	}
	
	/* Entry action for state 'Yellow'. */
	private void entryAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow() {
		timer.setTimer(this, 2, 2 * 1000, false);
		
		sCInterface.raiseDisplayYellow();
	}
	
	/* Entry action for state 'Green'. */
	private void entryAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green() {
		timer.setTimer(this, 3, 3 * 1000, false);
		
		sCInterface.raiseDisplayGreen();
	}
	
	/* Entry action for state 'Red'. */
	private void entryAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red() {
		timer.setTimer(this, 4, 5 * 1000, false);
		
		sCInterface.raiseDisplayRed();
	}
	
	/* Entry action for state 'Black'. */
	private void entryAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black() {
		timer.setTimer(this, 5, 1 * 1000, false);
		
		sCInterface.raiseDisplayNone();
	}
	
	/* Entry action for state 'Yellow'. */
	private void entryAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow() {
		timer.setTimer(this, 6, 1 * 1000, false);
		
		sCInterface.raiseDisplayYellow();
	}
	
	/* Entry action for state 'InPolice'. */
	private void entryAction_main_trafficsystem_acceptor_InPolice() {
		timer.setTimer(this, 7, 4 * 1000, false);
	}
	
	/* Entry action for state 'InNormal'. */
	private void entryAction_main_trafficsystem_acceptor_InNormal() {
		timer.setTimer(this, 8, 7 * 1000, false);
	}
	
	/* Entry action for state 'Waiting'. */
	private void entryAction_main_trafficsystem_acceptor_Waiting() {
		timer.setTimer(this, 9, 1 * 1000, false);
	}
	
	/* Exit action for state 'Waiting'. */
	private void exitAction_main_trafficsystem_generator_running_r1_Waiting() {
		timer.unsetTimer(this, 0);
	}
	
	/* Exit action for state 'GeneratingPolice'. */
	private void exitAction_main_trafficsystem_generator_running_r1_GeneratingPolice() {
		timer.unsetTimer(this, 1);
	}
	
	/* Exit action for state 'Yellow'. */
	private void exitAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow() {
		timer.unsetTimer(this, 2);
	}
	
	/* Exit action for state 'Green'. */
	private void exitAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green() {
		timer.unsetTimer(this, 3);
	}
	
	/* Exit action for state 'Red'. */
	private void exitAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red() {
		timer.unsetTimer(this, 4);
	}
	
	/* Exit action for state 'Black'. */
	private void exitAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black() {
		timer.unsetTimer(this, 5);
	}
	
	/* Exit action for state 'Yellow'. */
	private void exitAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow() {
		timer.unsetTimer(this, 6);
	}
	
	/* Exit action for state 'InPolice'. */
	private void exitAction_main_trafficsystem_acceptor_InPolice() {
		timer.unsetTimer(this, 7);
	}
	
	/* Exit action for state 'InNormal'. */
	private void exitAction_main_trafficsystem_acceptor_InNormal() {
		timer.unsetTimer(this, 8);
	}
	
	/* Exit action for state 'Waiting'. */
	private void exitAction_main_trafficsystem_acceptor_Waiting() {
		timer.unsetTimer(this, 9);
	}
	
	/* 'default' enter sequence for state trafficsystem */
	private void enterSequence_main_trafficsystem_default() {
		enterSequence_main_trafficsystem_generator_default();
		enterSequence_main_trafficsystem_trafficlight_default();
		enterSequence_main_trafficsystem_acceptor_default();
	}
	
	/* 'default' enter sequence for state running */
	private void enterSequence_main_trafficsystem_generator_running_default() {
		enterSequence_main_trafficsystem_generator_running_r1_default();
	}
	
	/* 'default' enter sequence for state Waiting */
	private void enterSequence_main_trafficsystem_generator_running_r1_Waiting_default() {
		entryAction_main_trafficsystem_generator_running_r1_Waiting();
		nextStateIndex = 0;
		stateVector[0] = State.main_trafficsystem_generator_running_r1_Waiting;
	}
	
	/* 'default' enter sequence for state GeneratingPolice */
	private void enterSequence_main_trafficsystem_generator_running_r1_GeneratingPolice_default() {
		entryAction_main_trafficsystem_generator_running_r1_GeneratingPolice();
		nextStateIndex = 0;
		stateVector[0] = State.main_trafficsystem_generator_running_r1_GeneratingPolice;
	}
	
	/* 'default' enter sequence for state GeneratingPolice2 */
	private void enterSequence_main_trafficsystem_generator_running_r1_GeneratingPolice2_default() {
		entryAction_main_trafficsystem_generator_running_r1_GeneratingPolice2();
		nextStateIndex = 0;
		stateVector[0] = State.main_trafficsystem_generator_running_r1_GeneratingPolice2;
	}
	
	/* 'default' enter sequence for state trafficlight */
	private void enterSequence_main_trafficsystem_trafficlight_trafficlight_default() {
		enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_default();
	}
	
	/* 'default' enter sequence for state normal */
	private void enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_default() {
		enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_default();
	}
	
	/* 'default' enter sequence for state Yellow */
	private void enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow_default() {
		entryAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow();
		nextStateIndex = 1;
		stateVector[1] = State.main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow;
		
		historyVector[0] = stateVector[1];
	}
	
	/* 'default' enter sequence for state Green */
	private void enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green_default() {
		entryAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green();
		nextStateIndex = 1;
		stateVector[1] = State.main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green;
		
		historyVector[0] = stateVector[1];
	}
	
	/* 'default' enter sequence for state Red */
	private void enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red_default() {
		entryAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red();
		nextStateIndex = 1;
		stateVector[1] = State.main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red;
		
		historyVector[0] = stateVector[1];
	}
	
	/* 'default' enter sequence for state interrupted */
	private void enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_default() {
		enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_default();
	}
	
	/* 'default' enter sequence for state Black */
	private void enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black_default() {
		entryAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black();
		nextStateIndex = 1;
		stateVector[1] = State.main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black;
	}
	
	/* 'default' enter sequence for state Yellow */
	private void enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow_default() {
		entryAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow();
		nextStateIndex = 1;
		stateVector[1] = State.main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow;
	}
	
	/* 'default' enter sequence for state InPolice */
	private void enterSequence_main_trafficsystem_acceptor_InPolice_default() {
		entryAction_main_trafficsystem_acceptor_InPolice();
		nextStateIndex = 2;
		stateVector[2] = State.main_trafficsystem_acceptor_InPolice;
	}
	
	/* 'default' enter sequence for state InNormal */
	private void enterSequence_main_trafficsystem_acceptor_InNormal_default() {
		entryAction_main_trafficsystem_acceptor_InNormal();
		nextStateIndex = 2;
		stateVector[2] = State.main_trafficsystem_acceptor_InNormal;
	}
	
	/* 'default' enter sequence for state Waiting */
	private void enterSequence_main_trafficsystem_acceptor_Waiting_default() {
		entryAction_main_trafficsystem_acceptor_Waiting();
		nextStateIndex = 2;
		stateVector[2] = State.main_trafficsystem_acceptor_Waiting;
	}
	
	/* 'default' enter sequence for state InNormal_2 */
	private void enterSequence_main_trafficsystem_acceptor_InNormal_2_default() {
		nextStateIndex = 2;
		stateVector[2] = State.main_trafficsystem_acceptor_InNormal_2;
	}
	
	/* 'default' enter sequence for state Timeout */
	private void enterSequence_main_trafficsystem_acceptor_Timeout_default() {
		nextStateIndex = 2;
		stateVector[2] = State.main_trafficsystem_acceptor_Timeout;
	}
	
	/* Default enter sequence for state null */
	private void enterSequence_main__final__default() {
		nextStateIndex = 0;
		stateVector[0] = State.main__final_;
	}
	
	/* 'default' enter sequence for region main */
	private void enterSequence_main_default() {
		react_main__entry_Default();
	}
	
	/* 'default' enter sequence for region generator */
	private void enterSequence_main_trafficsystem_generator_default() {
		react_main_trafficsystem_generator__entry_Default();
	}
	
	/* 'default' enter sequence for region r1 */
	private void enterSequence_main_trafficsystem_generator_running_r1_default() {
		react_main_trafficsystem_generator_running_r1__entry_Default();
	}
	
	/* 'default' enter sequence for region trafficlight */
	private void enterSequence_main_trafficsystem_trafficlight_default() {
		react_main_trafficsystem_trafficlight__entry_Default();
	}
	
	/* 'default' enter sequence for region trafficlight */
	private void enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_default() {
		react_main_trafficsystem_trafficlight_trafficlight_trafficlight__entry_Default();
	}
	
	/* 'default' enter sequence for region normal */
	private void enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_default() {
		react_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal__entry_Default();
	}
	
	/* shallow enterSequence with history in child normal */
	private void shallowEnterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal() {
		switch (historyVector[0]) {
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow:
			enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow_default();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green:
			enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green_default();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red:
			enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red_default();
			break;
		default:
			break;
		}
	}
	
	/* 'default' enter sequence for region interrupted */
	private void enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_default() {
		react_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted__entry_Default();
	}
	
	/* 'default' enter sequence for region acceptor */
	private void enterSequence_main_trafficsystem_acceptor_default() {
		react_main_trafficsystem_acceptor__entry_Default();
	}
	
	/* Default exit sequence for state trafficsystem */
	private void exitSequence_main_trafficsystem() {
		exitSequence_main_trafficsystem_generator();
		exitSequence_main_trafficsystem_trafficlight();
		exitSequence_main_trafficsystem_acceptor();
	}
	
	/* Default exit sequence for state Waiting */
	private void exitSequence_main_trafficsystem_generator_running_r1_Waiting() {
		nextStateIndex = 0;
		stateVector[0] = State.$NullState$;
		
		exitAction_main_trafficsystem_generator_running_r1_Waiting();
	}
	
	/* Default exit sequence for state GeneratingPolice */
	private void exitSequence_main_trafficsystem_generator_running_r1_GeneratingPolice() {
		nextStateIndex = 0;
		stateVector[0] = State.$NullState$;
		
		exitAction_main_trafficsystem_generator_running_r1_GeneratingPolice();
	}
	
	/* Default exit sequence for state GeneratingPolice2 */
	private void exitSequence_main_trafficsystem_generator_running_r1_GeneratingPolice2() {
		nextStateIndex = 0;
		stateVector[0] = State.$NullState$;
	}
	
	/* Default exit sequence for state normal */
	private void exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal() {
		exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal();
	}
	
	/* Default exit sequence for state Yellow */
	private void exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow() {
		nextStateIndex = 1;
		stateVector[1] = State.$NullState$;
		
		exitAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow();
	}
	
	/* Default exit sequence for state Green */
	private void exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green() {
		nextStateIndex = 1;
		stateVector[1] = State.$NullState$;
		
		exitAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green();
	}
	
	/* Default exit sequence for state Red */
	private void exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red() {
		nextStateIndex = 1;
		stateVector[1] = State.$NullState$;
		
		exitAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red();
	}
	
	/* Default exit sequence for state interrupted */
	private void exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted() {
		exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted();
	}
	
	/* Default exit sequence for state Black */
	private void exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black() {
		nextStateIndex = 1;
		stateVector[1] = State.$NullState$;
		
		exitAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black();
	}
	
	/* Default exit sequence for state Yellow */
	private void exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow() {
		nextStateIndex = 1;
		stateVector[1] = State.$NullState$;
		
		exitAction_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow();
	}
	
	/* Default exit sequence for state InPolice */
	private void exitSequence_main_trafficsystem_acceptor_InPolice() {
		nextStateIndex = 2;
		stateVector[2] = State.$NullState$;
		
		exitAction_main_trafficsystem_acceptor_InPolice();
	}
	
	/* Default exit sequence for state InNormal */
	private void exitSequence_main_trafficsystem_acceptor_InNormal() {
		nextStateIndex = 2;
		stateVector[2] = State.$NullState$;
		
		exitAction_main_trafficsystem_acceptor_InNormal();
	}
	
	/* Default exit sequence for state Waiting */
	private void exitSequence_main_trafficsystem_acceptor_Waiting() {
		nextStateIndex = 2;
		stateVector[2] = State.$NullState$;
		
		exitAction_main_trafficsystem_acceptor_Waiting();
	}
	
	/* Default exit sequence for state InNormal_2 */
	private void exitSequence_main_trafficsystem_acceptor_InNormal_2() {
		nextStateIndex = 2;
		stateVector[2] = State.$NullState$;
	}
	
	/* Default exit sequence for state Timeout */
	private void exitSequence_main_trafficsystem_acceptor_Timeout() {
		nextStateIndex = 2;
		stateVector[2] = State.$NullState$;
	}
	
	/* Default exit sequence for final state. */
	private void exitSequence_main__final_() {
		nextStateIndex = 0;
		stateVector[0] = State.$NullState$;
	}
	
	/* Default exit sequence for region main */
	private void exitSequence_main() {
		switch (stateVector[0]) {
		case main_trafficsystem_generator_running_r1_Waiting:
			exitSequence_main_trafficsystem_generator_running_r1_Waiting();
			break;
		case main_trafficsystem_generator_running_r1_GeneratingPolice:
			exitSequence_main_trafficsystem_generator_running_r1_GeneratingPolice();
			break;
		case main_trafficsystem_generator_running_r1_GeneratingPolice2:
			exitSequence_main_trafficsystem_generator_running_r1_GeneratingPolice2();
			break;
		case main__final_:
			exitSequence_main__final_();
			break;
		default:
			break;
		}
		
		switch (stateVector[1]) {
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow();
			break;
		default:
			break;
		}
		
		switch (stateVector[2]) {
		case main_trafficsystem_acceptor_InPolice:
			exitSequence_main_trafficsystem_acceptor_InPolice();
			break;
		case main_trafficsystem_acceptor_InNormal:
			exitSequence_main_trafficsystem_acceptor_InNormal();
			break;
		case main_trafficsystem_acceptor_Waiting:
			exitSequence_main_trafficsystem_acceptor_Waiting();
			break;
		case main_trafficsystem_acceptor_InNormal_2:
			exitSequence_main_trafficsystem_acceptor_InNormal_2();
			break;
		case main_trafficsystem_acceptor_Timeout:
			exitSequence_main_trafficsystem_acceptor_Timeout();
			break;
		default:
			break;
		}
	}
	
	/* Default exit sequence for region generator */
	private void exitSequence_main_trafficsystem_generator() {
		switch (stateVector[0]) {
		case main_trafficsystem_generator_running_r1_Waiting:
			exitSequence_main_trafficsystem_generator_running_r1_Waiting();
			break;
		case main_trafficsystem_generator_running_r1_GeneratingPolice:
			exitSequence_main_trafficsystem_generator_running_r1_GeneratingPolice();
			break;
		case main_trafficsystem_generator_running_r1_GeneratingPolice2:
			exitSequence_main_trafficsystem_generator_running_r1_GeneratingPolice2();
			break;
		default:
			break;
		}
	}
	
	/* Default exit sequence for region r1 */
	private void exitSequence_main_trafficsystem_generator_running_r1() {
		switch (stateVector[0]) {
		case main_trafficsystem_generator_running_r1_Waiting:
			exitSequence_main_trafficsystem_generator_running_r1_Waiting();
			break;
		case main_trafficsystem_generator_running_r1_GeneratingPolice:
			exitSequence_main_trafficsystem_generator_running_r1_GeneratingPolice();
			break;
		case main_trafficsystem_generator_running_r1_GeneratingPolice2:
			exitSequence_main_trafficsystem_generator_running_r1_GeneratingPolice2();
			break;
		default:
			break;
		}
	}
	
	/* Default exit sequence for region trafficlight */
	private void exitSequence_main_trafficsystem_trafficlight() {
		switch (stateVector[1]) {
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow();
			break;
		default:
			break;
		}
	}
	
	/* Default exit sequence for region trafficlight */
	private void exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight() {
		switch (stateVector[1]) {
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow();
			break;
		default:
			break;
		}
	}
	
	/* Default exit sequence for region normal */
	private void exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal() {
		switch (stateVector[1]) {
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red();
			break;
		default:
			break;
		}
	}
	
	/* Default exit sequence for region interrupted */
	private void exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted() {
		switch (stateVector[1]) {
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black();
			break;
		case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow:
			exitSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow();
			break;
		default:
			break;
		}
	}
	
	/* Default exit sequence for region acceptor */
	private void exitSequence_main_trafficsystem_acceptor() {
		switch (stateVector[2]) {
		case main_trafficsystem_acceptor_InPolice:
			exitSequence_main_trafficsystem_acceptor_InPolice();
			break;
		case main_trafficsystem_acceptor_InNormal:
			exitSequence_main_trafficsystem_acceptor_InNormal();
			break;
		case main_trafficsystem_acceptor_Waiting:
			exitSequence_main_trafficsystem_acceptor_Waiting();
			break;
		case main_trafficsystem_acceptor_InNormal_2:
			exitSequence_main_trafficsystem_acceptor_InNormal_2();
			break;
		case main_trafficsystem_acceptor_Timeout:
			exitSequence_main_trafficsystem_acceptor_Timeout();
			break;
		default:
			break;
		}
	}
	
	/* The reactions of state Waiting. */
	private void react_main_trafficsystem_generator_running_r1_Waiting() {
		if (check_main_trafficsystem_generator_running_tr0_tr0()) {
			effect_main_trafficsystem_generator_running_tr0();
		} else {
			if (check_main_trafficsystem_generator_running_r1_Waiting_tr0_tr0()) {
				effect_main_trafficsystem_generator_running_r1_Waiting_tr0();
			}
		}
	}
	
	/* The reactions of state GeneratingPolice. */
	private void react_main_trafficsystem_generator_running_r1_GeneratingPolice() {
		if (check_main_trafficsystem_generator_running_tr0_tr0()) {
			effect_main_trafficsystem_generator_running_tr0();
		} else {
			if (check_main_trafficsystem_generator_running_r1_GeneratingPolice_tr0_tr0()) {
				effect_main_trafficsystem_generator_running_r1_GeneratingPolice_tr0();
			}
		}
	}
	
	/* The reactions of state GeneratingPolice2. */
	private void react_main_trafficsystem_generator_running_r1_GeneratingPolice2() {
		if (check_main_trafficsystem_generator_running_tr0_tr0()) {
			effect_main_trafficsystem_generator_running_tr0();
		} else {
			if (check_main_trafficsystem_generator_running_r1_GeneratingPolice2_tr0_tr0()) {
				effect_main_trafficsystem_generator_running_r1_GeneratingPolice2_tr0();
			}
		}
	}
	
	/* The reactions of state Yellow. */
	private void react_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow() {
		if (check_main_trafficsystem_trafficlight_trafficlight_tr0_tr0()) {
			effect_main_trafficsystem_trafficlight_trafficlight_tr0();
		} else {
			if (check_main_trafficsystem_trafficlight_trafficlight_tr1_tr1()) {
				effect_main_trafficsystem_trafficlight_trafficlight_tr1();
			} else {
				if (check_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_tr0_tr0()) {
					effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_tr0();
				} else {
					if (check_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow_tr0_tr0()) {
						effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow_tr0();
					}
				}
			}
		}
	}
	
	/* The reactions of state Green. */
	private void react_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green() {
		if (check_main_trafficsystem_trafficlight_trafficlight_tr0_tr0()) {
			effect_main_trafficsystem_trafficlight_trafficlight_tr0();
		} else {
			if (check_main_trafficsystem_trafficlight_trafficlight_tr1_tr1()) {
				effect_main_trafficsystem_trafficlight_trafficlight_tr1();
			} else {
				if (check_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_tr0_tr0()) {
					effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_tr0();
				} else {
					if (check_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green_tr0_tr0()) {
						effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green_tr0();
					}
				}
			}
		}
	}
	
	/* The reactions of state Red. */
	private void react_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red() {
		if (check_main_trafficsystem_trafficlight_trafficlight_tr0_tr0()) {
			effect_main_trafficsystem_trafficlight_trafficlight_tr0();
		} else {
			if (check_main_trafficsystem_trafficlight_trafficlight_tr1_tr1()) {
				effect_main_trafficsystem_trafficlight_trafficlight_tr1();
			} else {
				if (check_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_tr0_tr0()) {
					effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_tr0();
				} else {
					if (check_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red_tr0_tr0()) {
						effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red_tr0();
					}
				}
			}
		}
	}
	
	/* The reactions of state Black. */
	private void react_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black() {
		if (check_main_trafficsystem_trafficlight_trafficlight_tr0_tr0()) {
			effect_main_trafficsystem_trafficlight_trafficlight_tr0();
		} else {
			if (check_main_trafficsystem_trafficlight_trafficlight_tr1_tr1()) {
				effect_main_trafficsystem_trafficlight_trafficlight_tr1();
			} else {
				if (check_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_tr0_tr0()) {
					effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_tr0();
				} else {
					if (check_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black_tr0_tr0()) {
						effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black_tr0();
					}
				}
			}
		}
	}
	
	/* The reactions of state Yellow. */
	private void react_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow() {
		if (check_main_trafficsystem_trafficlight_trafficlight_tr0_tr0()) {
			effect_main_trafficsystem_trafficlight_trafficlight_tr0();
		} else {
			if (check_main_trafficsystem_trafficlight_trafficlight_tr1_tr1()) {
				effect_main_trafficsystem_trafficlight_trafficlight_tr1();
			} else {
				if (check_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_tr0_tr0()) {
					effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_tr0();
				} else {
					if (check_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow_tr0_tr0()) {
						effect_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow_tr0();
					}
				}
			}
		}
	}
	
	/* The reactions of state InPolice. */
	private void react_main_trafficsystem_acceptor_InPolice() {
		if (check_main_trafficsystem_acceptor_InPolice_tr0_tr0()) {
			effect_main_trafficsystem_acceptor_InPolice_tr0();
		} else {
			if (check_main_trafficsystem_acceptor_InPolice_tr1_tr1()) {
				effect_main_trafficsystem_acceptor_InPolice_tr1();
			}
		}
	}
	
	/* The reactions of state InNormal. */
	private void react_main_trafficsystem_acceptor_InNormal() {
		if (check_main_trafficsystem_acceptor_InNormal_tr0_tr0()) {
			effect_main_trafficsystem_acceptor_InNormal_tr0();
		} else {
			if (check_main_trafficsystem_acceptor_InNormal_tr1_tr1()) {
				effect_main_trafficsystem_acceptor_InNormal_tr1();
			}
		}
	}
	
	/* The reactions of state Waiting. */
	private void react_main_trafficsystem_acceptor_Waiting() {
		if (check_main_trafficsystem_acceptor_Waiting_tr0_tr0()) {
			effect_main_trafficsystem_acceptor_Waiting_tr0();
		} else {
			if (check_main_trafficsystem_acceptor_Waiting_tr1_tr1()) {
				effect_main_trafficsystem_acceptor_Waiting_tr1();
			}
		}
	}
	
	/* The reactions of state InNormal_2. */
	private void react_main_trafficsystem_acceptor_InNormal_2() {
		if (check_main_trafficsystem_acceptor_InNormal_2_tr0_tr0()) {
			effect_main_trafficsystem_acceptor_InNormal_2_tr0();
		}
	}
	
	/* The reactions of state Timeout. */
	private void react_main_trafficsystem_acceptor_Timeout() {
		if (check_main_trafficsystem_acceptor_Timeout_tr0_tr0()) {
			effect_main_trafficsystem_acceptor_Timeout_tr0();
		}
	}
	
	/* The reactions of state null. */
	private void react_main__final_() {
	}
	
	/* Default react sequence for initial entry  */
	private void react_main_trafficsystem_generator_running_r1__entry_Default() {
		enterSequence_main_trafficsystem_generator_running_r1_Waiting_default();
	}
	
	/* Default react sequence for initial entry  */
	private void react_main_trafficsystem_generator__entry_Default() {
		enterSequence_main_trafficsystem_generator_running_default();
	}
	
	/* Default react sequence for initial entry  */
	private void react_main_trafficsystem_trafficlight_trafficlight_trafficlight__entry_Default() {
		enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_default();
	}
	
	/* Default react sequence for initial entry  */
	private void react_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal__entry_Default() {
		enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red_default();
	}
	
	/* Default react sequence for shallow history entry history */
	private void react_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_history() {
		/* Enter the region with shallow history */
		if (historyVector[0] != State.$NullState$) {
			shallowEnterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal();
		}
	}
	
	/* Default react sequence for initial entry  */
	private void react_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted__entry_Default() {
		enterSequence_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow_default();
	}
	
	/* Default react sequence for initial entry  */
	private void react_main_trafficsystem_trafficlight__entry_Default() {
		enterSequence_main_trafficsystem_trafficlight_trafficlight_default();
	}
	
	/* Default react sequence for initial entry  */
	private void react_main_trafficsystem_acceptor__entry_Default() {
		enterSequence_main_trafficsystem_acceptor_Waiting_default();
	}
	
	/* Default react sequence for initial entry  */
	private void react_main__entry_Default() {
		enterSequence_main_trafficsystem_default();
	}
	
	/* The reactions of state null. */
	private void react_main__sync0() {
		sCInterface.operationCallback.onTestPassed();
		
		enterSequence_main__final__default();
	}
	
	/* The reactions of state null. */
	private void react_main__sync1() {
		sCInterface.operationCallback.onTestFailed();
		
		enterSequence_main__final__default();
	}
	
	public void runCycle() {
		if (!initialized)
			throw new IllegalStateException(
					"The state machine needs to be initialized first by calling the init() function.");
		clearOutEvents();
		for (nextStateIndex = 0; nextStateIndex < stateVector.length; nextStateIndex++) {
			switch (stateVector[nextStateIndex]) {
			case main_trafficsystem_generator_running_r1_Waiting:
				react_main_trafficsystem_generator_running_r1_Waiting();
				break;
			case main_trafficsystem_generator_running_r1_GeneratingPolice:
				react_main_trafficsystem_generator_running_r1_GeneratingPolice();
				break;
			case main_trafficsystem_generator_running_r1_GeneratingPolice2:
				react_main_trafficsystem_generator_running_r1_GeneratingPolice2();
				break;
			case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow:
				react_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Yellow();
				break;
			case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green:
				react_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Green();
				break;
			case main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red:
				react_main_trafficsystem_trafficlight_trafficlight_trafficlight_normal_normal_Red();
				break;
			case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black:
				react_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Black();
				break;
			case main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow:
				react_main_trafficsystem_trafficlight_trafficlight_trafficlight_interrupted_interrupted_Yellow();
				break;
			case main_trafficsystem_acceptor_InPolice:
				react_main_trafficsystem_acceptor_InPolice();
				break;
			case main_trafficsystem_acceptor_InNormal:
				react_main_trafficsystem_acceptor_InNormal();
				break;
			case main_trafficsystem_acceptor_Waiting:
				react_main_trafficsystem_acceptor_Waiting();
				break;
			case main_trafficsystem_acceptor_InNormal_2:
				react_main_trafficsystem_acceptor_InNormal_2();
				break;
			case main_trafficsystem_acceptor_Timeout:
				react_main_trafficsystem_acceptor_Timeout();
				break;
			case main__final_:
				react_main__final_();
				break;
			default:
				// $NullState$
			}
		}
		clearEvents();
	}
}
