package traffic.light;

import traffic.light.trafficlightctrltest.ITrafficLightCtrlTestStatemachine;
import traffic.light.trafficlightctrltest.SynchronizedTrafficLightCtrlTestStatemachine;

public class TrafficlightDemo {

	protected SynchronizedTrafficLightCtrlTestStatemachine statemachine;

	protected TimerService timer;

	public static void main(String[] args) {
		TrafficlightDemo application = new TrafficlightDemo();
		application.setupStatemachine();
		application.run();
	}

	protected void run() {
		statemachine.enter();
		RuntimeService.getInstance().registerStatemachine(statemachine, 100);
	}

	protected void setupStatemachine() {
		statemachine = new SynchronizedTrafficLightCtrlTestStatemachine();
		timer = new TimerService();
		statemachine.setTimer(timer);
		statemachine.getSCInterface().setSCInterfaceOperationCallback(new ITrafficLightCtrlTestStatemachine.SCInterfaceOperationCallback() {
			@Override
			public void onTestPassed() {
				System.out.println("Test passed!");
				System.exit(0);
			}
			@Override
			public void onTestFailed() {
				System.out.println("Test failed!");
				System.exit(0);
			}
		});
		
		statemachine.init();
	}
}
