package traffic.light.trafficlightctrl;

import java.util.List;
import traffic.light.IStatemachine;
import traffic.light.ITimerCallback;

public interface ITrafficLightCtrlStatemachine extends ITimerCallback,IStatemachine {

	public interface SCInterface {
	
		public void raisePolice_interrupt();
		
		public void raiseToggle();
		
	}
	
	public SCInterface getSCInterface();
	
	public interface SCITrafficLight {
	
		public boolean isRaisedDisplayRed();
		
		public boolean isRaisedDisplayGreen();
		
		public boolean isRaisedDisplayYellow();
		
		public boolean isRaisedDisplayNone();
		
	public List<SCITrafficLightListener> getListeners();
	}
	
	public interface SCITrafficLightListener {
	
		public void onDisplayRedRaised();
		public void onDisplayGreenRaised();
		public void onDisplayYellowRaised();
		public void onDisplayNoneRaised();
		}
	
	public SCITrafficLight getSCITrafficLight();
	
	public interface SCITimer {
	
		public boolean isRaisedUpdateColor();
		
		public String getUpdateColorValue();
		
		public boolean isRaisedUpdateCounter();
		
		public long getUpdateCounterValue();
		
	public List<SCITimerListener> getListeners();
	}
	
	public interface SCITimerListener {
	
		public void onUpdateColorRaised(String value);
		public void onUpdateCounterRaised(long value);
		}
	
	public SCITimer getSCITimer();
	
}
