package traffic.light.trafficlightctrl;

import java.util.List;
import traffic.light.IStatemachine;
import traffic.light.ITimerCallback;

public interface ITrafficLightCtrlStatemachine extends ITimerCallback,IStatemachine {

	public interface SCInterface {
	
		public void raisePolice_interrupt();
		
		public boolean isRaisedDisplayRed();
		
		public boolean isRaisedDisplayGreen();
		
		public boolean isRaisedDisplayYellow();
		
		public boolean isRaisedDisplayNone();
		
	public List<SCInterfaceListener> getListeners();
	}
	
	public interface SCInterfaceListener {
	
		public void onDisplayRedRaised();
		public void onDisplayGreenRaised();
		public void onDisplayYellowRaised();
		public void onDisplayNoneRaised();
		}
	
	public SCInterface getSCInterface();
	
}
